<?php

namespace Tests\Feature\Services;

use App\Models\Token;
use App\Services\TokenService;
use Database\Factories\UserFactory;
use Illuminate\Foundation\Testing\DatabaseMigrations;
use Illuminate\Foundation\Testing\RefreshDatabase;
use Illuminate\Support\Facades\Hash;
use Tests\TestCase;

class TokenServiceTest extends TestCase
{
    use RefreshDatabase;
    use DatabaseMigrations;

    private TokenService $tokenService;

    protected function setUp(): void
    {
        parent::setUp(); // TODO: Change the autogenerated stub
        $this->tokenService = new TokenService();
    }

    public function testGenTokenWithInvalidEmailAndPasswordShouldThrowModelNotFoundException(): void
    {
        $this->expectException('Illuminate\Database\Eloquent\ModelNotFoundException');
        $this->tokenService->genToken('helloWorld@gmail.com', 'weqeqweqw');
    }

    public function testGenTokenWithValidEmailAndInvalidPasswordShouldThrowIllegalCredsException(): void
    {
        $this->expectException('App\Exceptions\IllegalCredsException');
        $user = UserFactory::new()->create();
        $this->tokenService->genToken($user->email, '12312313');
    }

    public function testGenTokenWithValidEmailAndPasswordShouldCreateTokenInstanceAndReturnAStringToken(): void
    {
        $user = UserFactory::new()->create(['password' => '123123']);
        $tokenString = $this->tokenService->genToken($user->email, '123123');

        $this->assertNotNull($tokenString);
        $this->assertDatabaseCount('tokens', 1);
        $token = Token::where('token', $tokenString)->first();
        $this->assertNotNull($token);
    }

    public function testGenTokenWithNullEmailAndPassswordShouldThrowTypeError(): void
    {
        $this->expectException('TypeError');
        $this->tokenService->genToken(null, '123131');
    }

    public function testGenTokenWithNullPasswordShouldThrowTypeError(): void
    {
        $this->expectException('TypeError');
        $this->tokenService->genToken('null', null);
    }

}
